

#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include <string.h>
#include <math.h>

#include <sys/types.h>
#include <stdlib.h>

/* #define PI 3.141565 */

int fd;
FILE *fp;

int steps;

#define MAXLENGHT 10*44100         /* 10 sec. samples enough ? */
short os[MAXLENGHT];


iwrite(fd,n,l)
int fd,l;
unsigned int n;
{
   write(fd,&n,l);
}

int initwav(s)                 /* Proto wav header, n=nnodes, filename */
char *s;
{
   fd = open(s,O_WRONLY|O_CREAT|O_TRUNC|O_BINARY);
   if (fd == NULL) return(-1);

   write(fd,"RIFF",4);
   iwrite(fd,(2*steps+36),4);
   write(fd,"WAVE",4);

   write(fd,"fmt ",4);
   iwrite(fd,(0x10),4);
   iwrite(fd,((short) 0x01),2);
   iwrite(fd,((short) 1),2);              /* Mono */
   iwrite(fd,(44100/1),4);                  /* Sample rate */
   iwrite(fd,(2*44100/1),4);
   iwrite(fd,((short) 2),2);
   iwrite(fd,((short) 16),2);

   write(fd,"data",4);
   iwrite(fd,(2*steps),4);
   return(0);
}


writewav(fd)
{
   int i;

   for (i=0; i<steps; i++)
      write(fd,&os[i],2);
   close(fd);
}

clear_os()
{
   int i;
   for (i=0; i<steps; i++)
       os[i] = 0;
}

gen_bd(start,length,ampl)
int start, length;
float ampl;
{
   int i;
   short t;

   /* printf("start= %d length = %d\n",start, length); */
   for (i=0; i<length; i++) {
      t = (short)
      ( (double) ampl*32000*
         (2.0/PI) * 5 * atan( 0.2 *
              ( (2.0/PI) *5 * atan( .2 *
                 sin(2*PI*50*(double)i/44100.0) )
              )
              * pow(.5,4* 6.0 * (double) i/ (double) (length)
            )
         )
      );
      /* printf("%d\n",(int) t); */
      os[i+start]+=t;
   }
}

gen_sd(start,length,ampl)
int start, length;
float ampl;
{
   int i;
   short t;
   double t1,t2,t3,t4;

   t1=t2=t3=t4=0.0;
   /* printf("start= %d length = %d\n",start, length); */
   for (i=0; i<length; i++) {
      t1 = (-1.0+2.0* ((double) rand()) /(double) RAND_MAX );
      t = (short)
      ( (double) ampl*32000*
         (2.0/PI) * 5 * atan( 0.2 *
              ( (2.0/PI) *10 * atan( .1 * 0.5 *
                 (
                    sin(2*PI*120*((double)i+5*t1)/44100.0) + 0.4 * t1
                 ) )
              )
              * pow(.5,3* 6.0 * (double) i/ (double) (length)
            )
         )
      );
      /* printf("%d\n",(int) t); */
      os[i+start]+=t;
      t2=t1;t3=t2;t4=t3;
   }
}

gen_hhc(start,length,ampl)
int start, length;
float ampl;
{
   int i;
   short t,t1,t2;

   t1=t2=0;

   /* printf("start= %d length = %d\n",start, length); */
   for (i=0; i<length; i++) {
      t = (int)
      ( (double) ampl*32000*
         (-1.0+2.0* ((double) rand()) /(double) RAND_MAX )
         /* sin(2*PI*50*(double)i/44100.0) */
      )
      * pow(.5,4* 6.0 * (double) i/ (double) (length) );
      /* printf("%d\n",(int) t); */
      t /= 3;
      os[i+start]+=t+t1+t2;
      t1 = t; t2 = t1;
   }
}

gen_hho(start,length,ampl)
int start, length;
float ampl;
{
   int i;
   short t,t1,t2;

   t1=t2=0;

   /* printf("start= %d length = %d\n",start, length); */
   for (i=0; i<0.9*length; i++) {
      t = (int)
      ( (double) ampl*32000*
         (-1.0+2.0* ((double) rand()) /(double) RAND_MAX )
         /* sin(2*PI*50*(double)i/44100.0) */
      )
      * pow(.5,4* .6 * (double) i/ (double) (length) );
      /* printf("%d\n",(int) t); */
      t /= 3;
      os[i+start]+=t+t1+t2;
      t1 = t; t2 = t1;
   }
   t1=t2=0;
   for (i=0; i<(1-0.9)*length; i++) {
      t = (int)
      ( (double) ampl*32000*
         (-1.0+2.0* ((double) rand()) /(double) RAND_MAX )
         /* sin(2*PI*50*(double)i/44100.0) */
      )
      * pow(.5,4* .6 * (double) (0.9 *(length-1))/ (double) (length) )
      * pow(.5,4* 6.0 * (double) i/ (double) (length) );
      /* printf("%d\n",(int) t); */
      t /= 3;
      os[i+start+(int) ((0.9) * length)]+=t+t1+t2;
      t1 = t; t2 = t1;
   }
}

#define MSEC(t) (int)(t*44.1)

add_sample(name,start,length, ampl)
char *name;
float start, length, ampl;
{
   if (strcmp(name,"s_bd") == 0) {
      gen_bd(MSEC(start),MSEC(length),ampl);
   }
   if (strcmp(name,"s_hhc") == 0) {
      gen_hhc(MSEC(start),MSEC(length),ampl);
   }
   if (strcmp(name,"s_hho") == 0) {
      gen_hho(MSEC(start),MSEC(length),ampl);
   }
   if (strcmp(name,"s_sd") == 0) {
      gen_sd(MSEC(start),MSEC(length),ampl);
   }
   if (strcmp(name,"len") == 0) {
      steps = MSEC(start);
      clear_os();
   }
}

/*    gen_bd(MSEC(   0),MSEC(200),0.9); */


#define MAXCOM 16*1024

read_com()
{
   int i;
   float t,l,a;

   static char b[MAXCOM];
   while (!feof(stdin) && fgets(b,MAXCOM,stdin) != NULL) {
      i=0;
      if (b[0] != '\n')
      {
         while (b[i] != ' ' && i<MAXCOM) i++;
         if (i>=MAXCOM) {write_com("error : data missing"); exit(-1); }
         if (sscanf(b+i+1,"%f %f %f",&t,&l,&a) == 3) {
            b[i] = '\0';
            add_sample(b,t,l,a);
         }
      }
   }

}

write_com(s)
char s[];
{
   printf("%s\n",s);
}



create_sample()            /* 120 BPM. 16th Quantized basic track */
{
   int t, n16;
   steps = MSEC(2000.0);
   clear_os();
   gen_bd(MSEC(   0),MSEC(200),0.9);
   gen_bd(MSEC( 750),MSEC(200),0.45);
   gen_bd(MSEC(1000),MSEC(200),0.9);
   n16=0;
   for (t=0; t<MSEC(2000); t+=MSEC(1000/8)) {
      if ((n16%16) == 10) {
         gen_hho(t,MSEC(240),.15);
      } else
         if ((n16%8) == 0)
            gen_hhc(t,MSEC(100),.4);
         else {
            if ((n16%2) == 0)
               gen_hhc(t,MSEC(100),.2);
         }
      if (n16 == 1)
         gen_hhc(t,MSEC(50),.3);
      n16++;
   }
   gen_sd(MSEC( 500),MSEC(300),0.8);
   gen_sd(MSEC(1500),MSEC(300),0.8);
}

int main(argc,argv)
int argc;
char *argv[];
{
   if (argc != 2) {
      printf("Usage: %s <outfile.wav>\n",argv[0]);
      exit(-1);
   }
   read_com();
   /* create_sample(); */
   /* clear_os(); */
   if (initwav(argv[1]) != 0) {
      printf("Cannot open output file %s.\n", argv[2]);
      exit(-3);
   }
   writewav(fd);
   write_com("end\n");
}
